commit 8250987299d01ff318b73a02e4ba245afd46b64b
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Thu Feb 8 13:59:42 2024 +0000

    libstdc++: Avoid aliasing violation in std::valarray [PR99117]
    
    The call to __valarray_copy constructs an _Array object to refer to
    this->_M_data but that means that accesses to this->_M_data are through
    a restrict-qualified pointer. This leads to undefined behaviour when
    copying from an _Expr object that actually aliases this->_M_data.
    
    Replace the call to __valarray_copy with a plain loop. I think this
    removes the only use of that overload of __valarray_copy, so it could
    probably be removed. I haven't done that here.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/99117
            * include/std/valarray (valarray::operator=(const _Expr&)):
            Use loop to copy instead of __valarray_copy with _Array.
            * testsuite/26_numerics/valarray/99117.cc: New test.
    
    (cherry picked from commit b58f0e5216a3053486e7f1aa96c3f2443b14d630)

diff --git a/libstdc++-v3/include/std/valarray b/libstdc++-v3/include/std/valarray
index 32e6e7e8a76..d4995977251 100644
--- a/libstdc++-v3/include/std/valarray
+++ b/libstdc++-v3/include/std/valarray
@@ -838,7 +838,13 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       // _GLIBCXX_RESOLVE_LIB_DEFECTS
       // 630. arrays of valarray.
       if (_M_size == __e.size())
-	std::__valarray_copy(__e, _M_size, _Array<_Tp>(_M_data));
+	{
+	  // Copy manually instead of using __valarray_copy, because __e might
+	  // alias _M_data and the _Array param type of __valarray_copy uses
+	  // restrict which doesn't allow aliasing.
+	  for (size_t __i = 0; __i < _M_size; ++__i)
+	    _M_data[__i] = __e[__i];
+	}
       else
 	{
 	  if (_M_data)
diff --git a/libstdc++-v3/testsuite/26_numerics/valarray/99117.cc b/libstdc++-v3/testsuite/26_numerics/valarray/99117.cc
new file mode 100644
index 00000000000..81621bd079a
--- /dev/null
+++ b/libstdc++-v3/testsuite/26_numerics/valarray/99117.cc
@@ -0,0 +1,17 @@
+// { dg-do run { target c++11 } }
+
+// PR libstdc++/99117 cannot accumulate std::valarray
+
+#include <valarray>
+#include <vector>
+#include <testsuite_hooks.h>
+
+int main()
+{
+    std::vector<std::valarray<int>> v = {{1,1}, {2,2}};
+    std::valarray<int> sum(2);
+    for (const auto& e : v)
+      sum = sum + e;
+    VERIFY(sum[0]==3);
+    VERIFY(sum[1]==3);
+}

